<?php
namespace ZEA2\Domain\Bundles\Avatar\Service;

use ZEA2\Domain\Bundles\Avatar\Definitions\Point;
use ZEA2\Domain\Bundles\Avatar\Exception\InvalidCropException;
use ZEA2\Domain\Bundles\Avatar\Image\ImageCollection;
use ZEA2\Domain\Bundles\Avatar\Parameters\UploadImageParameters;
use ZEA2\Domain\Bundles\Avatar\Service\Strategy\AvatarServiceStrategy;
use ZEA2\Domain\Bundles\Avatar\Strategy\ImageStrategy;

final class AvatarService
{
    const GENERATE_FILENAME_LENGTH = 8;

    /** @var AvatarServiceStrategy */
    private $strategy;

    public function __construct(AvatarServiceStrategy $strategy)
    {
        $this->strategy = $strategy;
    }

    public function uploadImage(ImageStrategy $strategy, UploadImageParameters $parameters): ImageCollection
    {
        $oldCollectionUID = null;

        if($strategy->getEntity()->hasImages()) {
            $oldCollectionUID = $strategy->getEntity()->getImages()->getUID();
        }

        $this->destroyImages($strategy);

        $source = $this->strategy->getImageFromPath($parameters->getTmpFile());

        $start = $parameters->getPointStart();
        $end = $parameters->getPointEnd();

        if($end->getX() === -1 && $end->getY() === -1) {
            $end = new Point($source->getWidth(), $source->getHeight());
        }

        if(($start->getX() > $end->getX()) || ($start->getY() > $end->getY())) {
            throw new InvalidCropException(sprintf('Invalid start/end points, got Point(%d, %d) – Point(%d, %d)',
                $start->getX(),
                $start->getY(),
                $end->getX(),
                $end->getY()
            ));
        }

        if(($source->getWidth() < $end->getX()) || ($source->getHeight() < $end->getY())) {
            throw new InvalidCropException(sprintf('Unable to crop with Point(%d, %d) – Point(%d, %d)',
                $start->getX(),
                $start->getY(),
                $end->getX(),
                $end->getY()
            ));
        }

        $source = $this->strategy->cropImage(
            $source,
            $end->getX() - $start->getX(),
            $end->getY() - $start->getY(),
            $start->getX(), 
            $start->getY()
        );

        $strategy->validate($source);
        $this->setImages($strategy, $this->strategy->generateImagesFromSource($strategy, $source));

        if($oldCollectionUID) {
            $strategy->getFilesystem()->deleteDir(sprintf('%s/%s', $strategy->getEntityId(), $oldCollectionUID));
        }

        return $strategy->getEntity()->getImages();
    }

    public function generateImage(ImageStrategy $strategy): ImageCollection
    {
        $this->destroyImages($strategy);

        $oldCollectionUID = $strategy->getEntity()->hasImages()
            ? $oldCollectionUID = $strategy->getEntity()->getImages()->getUID()
            : false
        ;

        $images = $this->strategy->generateImagesFromLetter($strategy, $strategy->getLetter());
        $images->markAsAutoGenerated();

        $this->setImages($strategy, $images);

        if($oldCollectionUID) {
            $strategy->getFilesystem()->deleteDir(sprintf('%s/%s', $strategy->getEntityId(), $oldCollectionUID));
        }

        return $strategy->getEntity()->getImages();
    }

    public function destroyImages(ImageStrategy $strategy)
    {
        $fs = $strategy->getFilesystem();
        $dir = (string) $strategy->getEntityId();

        if($fs->has($dir)) {
            $fs->deleteDir($dir);
        }
    }

    private function setImages(ImageStrategy $strategy, ImageCollection $collection)
    {
        if($collection->hasImage($strategy->getDefaultSize())) {
            $collection->attachImage('default', clone $collection->getImage((string) $strategy->getDefaultSize()));
        }else{
            $collection->attachImage('default', clone $collection->getImage(max($strategy->getSizes())));
        }

        $strategy->getEntity()->setImages($collection);
    }
}